package com.quickblox.quickblox_sdk;

import android.content.Context;

import androidx.test.platform.app.InstrumentationRegistry;

import com.quickblox.auth.session.QBSettings;
import com.quickblox.core.exception.QBResponseException;
import com.quickblox.users.QBUsers;
import com.quickblox.users.model.QBUser;

import junit.framework.TestCase;

import io.flutter.plugin.common.MethodChannel;

public class BaseTest extends TestCase {
    public static final int USER_ID = 0;
    public static final String USER_PASSWORD = "";
    public static final String USER_LOGIN = "";

    public static final String APPLICATION_ID = "";
    public static final String AUTHORIZATION_KEY = "";
    public static final String AUTHORIZATION_SECRET = "";
    public static final String ACCOUNT_KEY = "";

    public static final String DIALOG_ID = "";

    protected Context context;

    protected void initContext() {
        this.context = InstrumentationRegistry.getInstrumentation().getTargetContext();
    }

    protected void initCredentials() {
        QBSettings.getInstance().init(context, APPLICATION_ID, AUTHORIZATION_KEY, AUTHORIZATION_SECRET);
        QBSettings.getInstance().setAccountKey(ACCOUNT_KEY);
    }

    protected QBUser buildUser() {
        QBUser user = new QBUser();
        user.setPassword(USER_PASSWORD);
        user.setId(BaseTest.USER_ID);
        user.setLogin(USER_LOGIN);

        return user;
    }

    protected void login() throws QBResponseException {
        QBUser user = buildUser();
        QBUsers.signIn(user).perform();
    }

    protected void logout() throws QBResponseException {
        QBUsers.signOut().perform();
    }

    protected static class ResultImpl implements MethodChannel.Result {
        @Override
        public void success(Object o) {

        }

        @Override
        public void error(String s, String s1, Object o) {
            throw new RuntimeException(s);
        }

        @Override
        public void notImplemented() {
            throw new RuntimeException("This method hasn't implemented yet");
        }
    }
}