package com.quickblox.quickblox_sdk.chat;

import androidx.test.internal.runner.junit4.AndroidJUnit4ClassRunner;

import com.quickblox.core.exception.QBResponseException;
import com.quickblox.quickblox_sdk.BaseTest;
import com.quickblox.quickblox_sdk.chat.utils.ChatFilterUtils;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.junit.runner.RunWith;

import java.util.HashMap;
import java.util.List;
import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

import io.flutter.plugin.common.MethodCall;

import static androidx.test.platform.app.InstrumentationRegistry.getInstrumentation;

@RunWith(AndroidJUnit4ClassRunner.class)
public class GetDialogsTest extends BaseTest {

    @Before
    public void before() {
        super.initContext();
        super.initCredentials();

        try {
            new CountDownLatch(1).await(15, TimeUnit.SECONDS);
            login();
        } catch (QBResponseException | InterruptedException e) {
            e.printStackTrace();
            throw new RuntimeException("Error init() method " + e.getMessage());
        }
    }

    @After
    public void after() {
        try {
            logout();
        } catch (QBResponseException e) {
            e.printStackTrace();
            throw new RuntimeException("Error release() method " + e.getMessage());
        }
    }

    @Test
    public void getDialogsByFilterUserId() throws InterruptedException {
        CountDownLatch downLatch = new CountDownLatch(1);

        MethodCall methodCall = new MethodCall(ChatModule.GET_DIALOGS_METHOD, ChatFilterUtils.buildFilterDialogId(BaseTest.DIALOG_ID));

        getInstrumentation().runOnMainSync(() -> new ChatModule().handleMethod(methodCall, new ResultImpl() {
            @Override
            public void success(Object o) {
                int dialogsSize = ((List<Object>) ((HashMap) o).get("dialogs")).size();
                assertEquals(1, dialogsSize);
                downLatch.countDown();
            }
        }));

        downLatch.await(10, TimeUnit.SECONDS);
        assertEquals(0, downLatch.getCount());
    }
}
