///Created by Injoit on 2022-04-06.
///Copyright © 2022 Quickblox. All rights reserved.
import 'package:quickblox_sdk/models/qb_ice_server.dart';

class IceServerUtil {
  static List<QBIceServer> build_3_correct_1_wrong_IceServers() {
    List<QBIceServer> iceServers = [];

    iceServers.add(_buildIceServer("stun:stun.l.google.com:19302", "", ""));

    iceServers.add(_buildIceServer(
        "stun:turn.quickblox.com", "quickblox", "baccb97ba2d92d71e26eb9886da5f1e0"));

    iceServers.add(_buildIceServer("", "quickblox", ""));

    iceServers.add(_buildIceServer("turn:turn.quickblox.com:3478?transport=udp", "quickblox",
        "baccb97ba2d92d71e26eb9886da5f1e0"));

    return iceServers;
  }

  static List<QBIceServer> buildWrongIceServers() {
    List<QBIceServer> iceServers = [];

    iceServers.add(_buildIceServer("", "", ""));
    iceServers.add(_buildIceServer("", "quickblox", "baccb97ba2d92d71e26eb9886da5f1e0"));
    iceServers.add(_buildIceServer("", "quickblox", "baccb97ba2d92d71e26eb9886da5f1e0"));
    iceServers.add(_buildIceServer("", "quickblox", "baccb97ba2d92d71e26eb9886da5f1e0"));

    return iceServers;
  }

  static List<QBIceServer> buildCorrectIceServers() {
    List<QBIceServer> iceServers = [];

    iceServers.add(_buildIceServer("stun:stun.l.google.com:19302", "", ""));

    iceServers.add(_buildIceServer(
        "stun:turn.quickblox.com", "quickblox", "baccb97ba2d92d71e26eb9886da5f1e0"));

    iceServers.add(_buildIceServer("turn:turn.quickblox.com:3478?transport=udp", "quickblox",
        "baccb97ba2d92d71e26eb9886da5f1e0"));

    iceServers.add(_buildIceServer("turn:turn.quickblox.com:3478?transport=tcp", "quickblox",
        "baccb97ba2d92d71e26eb9886da5f1e0"));

    return iceServers;
  }

  static QBIceServer _buildIceServer(String url, String? userName, String? password) {
    QBIceServer qbIceServer = QBIceServer();

    qbIceServer.url = url;
    qbIceServer.userName = userName;
    qbIceServer.password = password;

    return qbIceServer;
  }
}
